                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
                                                                                                                    

ReviewPages = {};

ReviewPages.displayLiveTableRow = function(row, i, table) {
  var tr = new Element('tr');
  if (row.doc_viewable) {
    var docLink = new Element('a', {'href' : row.doc_url}).update(row.doc_name);
    tr.appendChild(new Element('td').update(docLink));
    tr.appendChild(new Element('td').update(row.doc_space));
    tr.appendChild(new Element('td').update(row.doc_date));
    var authorLink = new Element('a', {'href' : row.doc_author_url}).update(row.doc_author);
    tr.appendChild(new Element('td').update(authorLink));
    var tdNextReview = new Element('td', {'class' : 'reviewDate'}).update(row.nextReviewDate);
    var reviewDate = new Date(row.nextReviewDate); // FIXME: try be date format invariant!
    var isOverdue = (!reviewDate || (reviewDate.isBefore(new Date())) || isNaN(reviewDate.getTime()) );
    if (isOverdue) {
      tdNextReview.addClassName('overdue');
    }
    tr.appendChild(tdNextReview);
    tr.appendChild(new Element('td').update(row.lastReviewer));
    tr.appendChild(new Element('td').update(row.reviewDate));

    var actions = new Element('td');
    var viewLink = new Element('a', {'href': row.doc_url, target: '_new'}).update("View");
    actions.appendChild(viewLink);
    // todo: only if "canReview" ...
    if (row.doc_hasedit) {
        actions.appendChild( new Element('br')); // ToDo: style actions instead
        var reviewLink = new Element('a', {'href' : row.doc_url,'class':'reviewLink'}).update("Review");
        actions.appendChild(reviewLink);
        reviewLink.observe('click', function(e) {
          e.stop();
          new ReviewPages.ReviewDialog({'doc_url': row.doc_url, 'doc_fullName': row.doc_fullName});
          return false;
        });
        actions.appendChild( new Element('br'));
        var removeReviewLink = new Element('a', {'href': row.doc_url, 'class': 'removeReviewLink', 'title': "Remove from review"}).update("Remove");
        actions.appendChild(removeReviewLink);
        removeReviewLink.observe('click', function(e) {
          e.stop();
          ReviewPages.removeReviewDialog(row.doc_fullName, row.doc_name);
          return false;
        });
    }
    tr.appendChild(actions);
  }
  return tr;
}

ReviewPages.reloadLiveTable = function() {
  // reload/update livetable
  // the following does not work: no update, as filters have not changed ....
  // Event.fire( $('review'), 'xwiki:livetable:review:filtersChanged');
  // instead we use the global variable and access the table 
  var livetable = window.livetable_review;
  var end = livetable.limit;
  var start = Math.max(livetable.lastOffset, 1);
  livetable.clearCache();
  livetable.getRows(start, end, start, end);
}
ReviewPages.displayError = function(errorMessage) {
  if (!errorMessage) {
    errorMessage = "Internal Server Error";
  }
  new XWiki.widgets.Notification("Fehlgeschlagen:" + errorMessage, "error");
}

ReviewPages.ReviewDialog = Class.create(XWiki.widgets.ModalPopup, {
  defaultInteractionParameters: {
    loadContentUrl: "http:\/\/help6.formcycle.eu:80\/xwiki\/bin\/view\/ReviewPages\/Script?xpage=plain",
  },
  initialize: function($super, interactionParameters) {
    this.interactionParameters = Object.extend(Object.clone(this.defaultInteractionParameters), interactionParameters || {});
    // call constructor from ModalPopup with params content, shortcuts, options
    $super(
      // this element will end up as this.content
      new Element('form', {'class' : 'xform'}),
      {
        "show": {method: this.showDialog, keys: []},
        "close": {method: this.closeDialog, keys: ['Esc']}
      },
      {
        verticalPosition: "top",
        backgroundColor: "#fafafa",
        title : "Review this page"
      }
    );
    this.loadContent();
    this.showDialog();
    this.setClass("moccacal-modal-popup");
    this.savingBox = new XWiki.widgets.Notification("Sende Anfrage...", "inprogress", {inactive: true});
    $$(".xdialog-modal-container").each(function(div) { div.setStyle({position: 'absolute'}) });
  },
  loadContent: function() {
    new Ajax.Request( this.interactionParameters.loadContentUrl, {
      method: 'get',
      parameters: { 'reDoc' : this.interactionParameters.doc_fullName },
      onSuccess: function(response) {
        if (response.status == 0) {
          return;
        }
        try {
          var responseText = response.responseText || "no response text";
          var old = $('formcontent');
          if (old) {
            old.purge();
            old.remove();
          }
          this.content.insert('<div id="formcontent">' + responseText + '</div>');
          var formcontent = $('formcontent');
          Element.select(formcontent,'input.datetime').each(function(dateTimeInput) {
            new XWiki.DateTimePicker(dateTimeInput, dateTimeInput.title);
          });
          this.content.observe('submit', this.submitReviewForm.bind(this));
          var buttons = new Element('div', {'class':'buttons'});
          buttons.insert(this.createButton("button","Set next review","","update-review","btn"));
          buttons.insert(this.createButton("button","Cancel","","cancel-review","btn"));
          buttons.down('#update-review').observe('click', this.submitReviewForm.bind(this));
          buttons.down('#cancel-review').observe('click', this.closeDialog.bind(this));
          formcontent.insert(buttons);
        } catch (e) { ReviewPages.displayError(e); console.log(e); }
      }.bind(this),
      onFailure: function() {
        ReviewPages.displayError();
      }
    });
  },
  submitReviewForm: function(event) {
    if (event) { event.stop(); }
    this.savingBox.show();
    this.content.writeAttribute('action', "http:\/\/help6.formcycle.eu:80\/xwiki\/bin\/get\/ReviewPages\/UpdateService");
    this.content.request({
      onSuccess: function(response) {
        if (response.status == 0) {
          return;
        }
        this.savingBox.hide();
        if ( !response.responseJSON || response.responseJSON.error) {
          ReviewPages.displayError(response.responseJSON?response.responseJSON.error:'')
        } else {
          new XWiki.widgets.Notification("Fertig!", "done");
          this.closeDialog();
          ReviewPages.reloadLiveTable();
        }
      }.bind(this),
      onFailure: function(e) {
        this.savingBox.hide();
        ReviewPages.displayError();
      }.bind(this)
    });
  }
});

ReviewPages.removeReviewDialog = function(pageFullName, pageName) {

  new XWiki.widgets.ConfirmationBox({ 
    onYes: function() { 
      new Ajax.Request( "http:\/\/help6.formcycle.eu:80\/xwiki\/bin\/view\/ReviewPages\/RemoveScript", {
        method: 'get',
        parameters: { 'reDoc': pageFullName, 'outputSyntax': 'plain', 'xpage': 'plain' },
        onSuccess: function(response) {
          if (response.status == 0) {
            return;
          }
          try {
            var responseJSON = response.responseJSON;
            var error = (responseJSON)?responseJSON.error:"Internal Server Error";
            if (error) {
              ReviewPages.displayError(error);
            } else {
              new XWiki.widgets.Notification("Fertig!", "done");
              ReviewPages.reloadLiveTable();
            }
          } catch (e) { ReviewPages.displayError(e); }
        },
        onFailure: function() {
          ReviewPages.displayError();
        }
      });
    }
  },
  { confirmationText: "Do you really want to remove &#171;{0}&#187; from the review process?".sub("{0}", pageName),
       yesButtonText: "Ja",
        noButtonText: "Nein"
  });
};


(function(){
  function initDatePicker() {
     var dateFormat = "$escapetool.javascript($xwiki.getDocument('ReviewPages.ReviewData').getxWikiClass().get('nextReviewDate').getPropertyClass().getDateFormat())";
     new XWiki.DateTimePicker($('addReviewPage_nextReviewDate').addClassName('datetime'), dateFormat)
  }
  (XWiki && XWiki.domIsLoaded && initDatePicker()) || document.observe("xwiki:dom:loaded", initDatePicker);
})()

